config/routes.rb
Bulletins::Engine.routes.draw do
  resources :bulletins do
    member do
      post 'send_emails'
    end
  end
  # For BasicDistribution
  # Bulletins.distribution_controller.constantize.controller_name.to_sym
  resources :basic_distributions do
    member do
      post 'add_recipient'
    end
  end
end

app/models/bulletins/application_record.rb
module Bulletins
  class ApplicationRecord < ::ApplicationRecord
    self.abstract_class = true
  end
end

app/models/bulletins/basic_distribution.rb
module Bulletins
  ##
  # The default distribution model.
  #
  # Uses DistributionRecipient and Recipient to store email addresses.
  class BasicDistribution < Distribution
    self.table_name = "bulletins_distributions"
    has_many :distribution_recipients, foreign_key: "distribution_id"
    has_many :recipients, through: :distribution_recipients
    validates :name, presence: true

    # Adds email address to this distribution
    def add_recipient(email)
      self.class.transaction do
        DistributionRecipient.find_or_create_by!(
          distribution: self,
          recipient: Recipient.find_or_create_by!(email: email)
        )
      end
    end

    def name_with_count
      name + " (" + recipients.count.to_s + ")"
    end
  end
end

app/models/bulletins/bulletin.rb
module Bulletins
  class Bulletin < ApplicationRecord
    has_rich_text :content
    validates :subject, length: { maximum: 191 }
    belongs_to :distribution, class_name: Bulletins.distribution_class_name, optional: true

    # TODO once sent this will be inaccurate if the distribution has changed
    def recipients
      distribution&.recipients
    end

    def draft?
      !sent?
    end

    def sent?
      sent_at.present?
    end

    def readonly
      sent?
    end

    # Send out email to all recipients
    def send_emails
      if sent?
        raise Error, "Bulletin \##{id} has already been sent."
      end
      # BulletinMailerJob.perform_later
      update sent_at: Time.current, sent_count: recipients.count
    end
  end
end

app/models/bulletins/distribution.rb
module Bulletins
  # A bulletin has one distribution, which is set of email recipients.
  #
  # Subclass or use a guide when creating a custom system for retrieving bulletin recipients.
  class Distribution < ApplicationRecord
    self.abstract_class = true
    has_many :bulletins
  end
end

app/models/bulletins/distribution_recipient.rb
module Bulletins
  # Join table that links BasicDistribution and Recipient
  class DistributionRecipient < ApplicationRecord
    belongs_to :distribution, foreign_key: "distribution_id", class_name: "Bulletins::BasicDistribution", inverse_of: :distribution_recipients
    belongs_to :recipient
  end
end

app/models/bulletins/recipient.rb
module Bulletins
  # Table with email addresses
  class Recipient < ApplicationRecord
    has_many :distribution_recipients
    has_many :distributions, through: :distribution_recipients
  end
end

app/controllers/bulletins/application_controller.rb
module Bulletins
  class ApplicationController < ::ApplicationController
  end
end

app/controllers/bulletins/basic_distributions_controller.rb
module Bulletins
  class BasicDistributionsController < ApplicationController
    before_action :set_distribution, only: %i[ show edit update destroy add_recipient ]

    def index
      @distributions = BasicDistribution.all
    end

    def show
    end

    def new
      @distribution = BasicDistribution.new
    end

    def edit
    end

    def create
      @distribution = BasicDistribution.new(distribution_params)

      if @distribution.save
        redirect_to @distribution, notice: "Distribution was successfully created."
      else
        render :new, status: :unprocessable_entity
      end
    end

    def add_recipient
      @distribution.add_recipient params[:email]
      redirect_to action: :edit
    end

    def update
      if @distribution.update(distribution_params)
        redirect_to @distribution, notice: "Distribution was successfully updated."
      else
        render :edit, status: :unprocessable_entity
      end
    end

    def destroy
      @distribution.destroy
      redirect_to basic_distributions_url, notice: "Distribution was successfully destroyed."
    end

    private
      # Use callbacks to share common setup or constraints between actions.
      def set_distribution
        @distribution = BasicDistribution.find(params[:id])
      end

      # Only allow a list of trusted parameters through.
      def distribution_params
        params.require(:basic_distribution).permit(:name)
      end
  end
end

app/controllers/bulletins/bulletins_controller.rb
module Bulletins
  class BulletinsController < ApplicationController
    before_action :set_bulletin, only: %i[ show edit update destroy ]

    # GET /bulletins
    def index
      @bulletins = Bulletin.all
    end

    # GET /bulletins/1
    def show
    end

    # GET /bulletins/new
    def new
      @bulletin = Bulletin.new
    end

    # GET /bulletins/1/edit
    def edit
    end

    # POST /bulletins
    def create
      @bulletin = Bulletin.new(bulletin_params)

      if @bulletin.save
        redirect_to @bulletin, notice: "Bulletin was successfully created."
      else
        render :new, status: :unprocessable_entity
      end
    end

    # PATCH/PUT /bulletins/1
    def update
      if @bulletin.update(bulletin_params)
        redirect_to @bulletin, notice: "Bulletin was successfully updated."
      else
        render :edit, status: :unprocessable_entity
      end
    end

    # DELETE /bulletins/1
    def destroy
      @bulletin.destroy
      redirect_to bulletins_url, notice: "Bulletin was successfully destroyed."
    end

    # POST /bulletins/1/send_emails
    def send_emails
      @bulletin.send_emails
    end

    private
      def set_bulletin
        @bulletin = Bulletin.find(params[:id])
      end

      def bulletin_params
        params.require(:bulletin).permit(:subject, :content, :distribution_id)
      end
  end
end

app/helpers/bulletins/application_helper.rb
module Bulletins
  module ApplicationHelper
    def basic_distribution_options_for_select(selected = nil)
      options_for_select(Bulletins::BasicDistribution.all.map do |d|
        [d.name_with_count, d.id]
      end, selected: selected)
    end
  end
end

app/helpers/bulletins/distributions_helper.rb
module Bulletins
  module DistributionsHelper
  end
end

app/views/active_storage/blobs/_blob.html.erb
<figure class="attachment attachment--<%= blob.representable? ? "preview" : "file" %> attachment--<%= blob.filename.extension %>">
  <% if blob.representable? %>
    <%= image_tag blob.representation(resize_to_limit: local_assigns[:in_gallery] ? [ 800, 600 ] : [ 1024, 768 ]) %>
  <% end %>

  <figcaption class="attachment__caption">
    <% if caption = blob.try(:caption) %>
      <%= caption %>
    <% else %>
      <span class="attachment__name"><%= blob.filename %></span>
      <span class="attachment__size"><%= number_to_human_size blob.byte_size %></span>
    <% end %>
  </figcaption>
</figure>

app/views/bulletins/basic_distributions/_error.html.haml
.alert.alert-warning.p-4
  %h2= "#{pluralize(@distribution.errors.count, "error")} prohibited this distribution from being saved:"
  %ul
    - @distribution.errors.full_messages.each do |message|
      %li= message

app/views/bulletins/basic_distributions/_form.html.haml
= form_with(model: @distribution, class: 'row') do |f|
  - if @distribution.errors.any?
    = render "error"
  .col-auto
    .mb-2.input-group
      = f.text_field :name, class: 'form-control', placeholder: 'Name'
      = f.submit 'Save', class: 'btn btn-outline-primary'

app/views/bulletins/basic_distributions/_new_recipient.html.haml
= form_with url: add_recipient_basic_distribution_path(@distribution), class: "row" do |f|
  .col-auto
    .mb-2.input-group
      = f.email_field :email, placeholder: "Add a new email", class: 'form-control'
      = f.submit 'Add', class: 'btn btn-outline-primary'

app/views/bulletins/basic_distributions/_recipients.html.haml
%table.table
  %thead
    %tr
      %th Recipients
  %tbody
    - @distribution.recipients.each do |r|
      %tr
        %td= r.email

app/views/bulletins/basic_distributions/edit.html.haml
%h1 Editing distribution

= render 'form'

= render 'recipients'

= render 'new_recipient'

= link_to 'Show', @distribution, class: 'btn btn-info'
= link_to 'Back', basic_distributions_path, class: 'btn btn-secondary'

app/views/bulletins/basic_distributions/index.html.haml
%h1 Distributions

%table.table
  %thead
    %tr
      %th Name
      %th
      %th
      %th

  %tbody
    - @distributions.each do |distribution|
      %tr
        %td= distribution.name_with_count
        %td= link_to 'Show', distribution
        %td= link_to 'Edit', edit_basic_distribution_path(distribution)
        %td= link_to 'Destroy', distribution, method: :delete, data: { confirm: 'Are you sure?' }

%div.mt-2
  = link_to 'New Distribution', new_basic_distribution_path, class: 'btn btn-primary'
  = link_to 'Bulletins', bulletins_path, class: 'btn btn-secondary'

app/views/bulletins/basic_distributions/new.html.haml
%h1 New distribution

= render 'form'

= link_to 'Back', basic_distributions_path

app/views/bulletins/basic_distributions/show.html.haml
- if notice
  #notice.alert.alert-primary= notice

%p
  %b Name:
  = @distribution.name

- if @distribution.recipients.count.positive?
  = render 'recipients'
- else
  %b No recipients

%div.mt-2
  = link_to 'Edit', edit_basic_distribution_path(@distribution), class: 'btn btn-primary'
  = link_to 'Back', basic_distributions_path, class: 'btn btn-secondary'

app/views/bulletins/bulletins/_basic_distribution_form.html.haml
= form.label :distribution_id, "Select Distribution"
= form.select :distribution_id, basic_distribution_options_for_select(@bulletin.distribution_id), { include_blank: true }, { class: "form-select" }

app/views/bulletins/bulletins/_error.html.haml
%div.bulletins-error.alert.alert-warning
  %h2= pluralize(bulletin.errors.count, "error") + " prohibited this bulletin from being saved"
  %ul
    - bulletin.errors.each do |error|
      %li= error.full_message

app/views/bulletins/bulletins/_form.html.haml
.p-2
  = form_with(model: @bulletin) do |form|
    - if @bulletin.errors.any?
      = render "error", { bulletin: @bulletin }
    %div.mb-2
      = form.label :subject
      = form.text_field :subject, required: true
    %div.mb-2
      = render Bulletins.bulletin_form_partial, { form: form }
    %div.mb-2
      = form.label :content
      = form.rich_text_area :content
    %div.mb-2
      = form.submit class: 'btn btn-primary'

app/views/bulletins/bulletins/edit.html.haml
%h1 Edit Bulletin

= render "form"

%div
  = link_to "Show this bulletin", @bulletin
  = link_to "Back to bulletins", bulletins_path

app/views/bulletins/bulletins/index.html.haml
#bulletins
  %table.table.table-borderless
    %thead
      %tr
        %th Bulletin
        %th Subject
        %th Created
        %th Sent
        %th Recipients
    %tbody
      - @bulletins.each do |bulletin|
        %tr
          %td= link_to "Bulletin \##{bulletin.id}", bulletin
          %td= bulletin.subject.present? ? bulletin.subject : tag.span("no subject", class: 'fst-italic')
          %td= bulletin.created_at.strftime("%F")
          %td= bulletin.sent? ? bulletin.sent_at.strftime("%F") : "-"
          %td= bulletin.recipients&.count || '-'


  %div.m-1
    = link_to "New Bulletin", new_bulletin_path, class: "btn btn-primary"
    = link_to "New Distribution", new_basic_distribution_path, class: "btn btn-primary"

app/views/bulletins/bulletins/new.html.haml
%h1 New Bulletin

= render "form"

app/views/bulletins/bulletins/show.html.haml
- if @bulletin.sent?
  %div.alert.alert-info
    %p Sent to #{@bulletin.sent_count} recipients on #{@bulletin.sent_at.to_formatted_s(:short)}

%div.mt-2.p-2
  .input-group
    %span.input-group-text Subject
    %input.form-control{type: "text", value: @bulletin.subject, readonly: true}

%div.m-2.p-2.border
  %div= @bulletin.content

%div.mt-2.p-2
  - if @bulletin.distribution
    = link_to "Distribution: #{@bulletin.distribution.name}", @bulletin.distribution

%div.mt-2.p-2
  - if @bulletin.distribution
    = button_to "Send to #{@bulletin.recipients.count} recipients", @bulletin, { class: "btn btn-success", disabled: @bulletin.sent?, form_class: "d-inline", data: { confirm: "Are you sure?" } }
  = link_to "Edit this bulletin", edit_bulletin_path(@bulletin), { class: "btn btn-primary #{@bulletin.sent? ? 'disabled' : ''}" }
  = link_to "Back to bulletins", bulletins_path, class: "btn btn-secondary"
  = button_to "Destroy this bulletin", @bulletin, { method: :delete, class: "btn btn-danger", disabled: @bulletin.sent?, form_class: "d-inline", data: { confirm: "Are you sure?" } }

app/views/layouts/bulletins/application.html.haml
!!! 5
%html
  %head
    = stylesheet_link_tag    "trix", media: "all"
    = javascript_include_tag "trix", type: "module"
    = javascript_include_tag "actiontext", type: "module"
    - if content_for?(:head)
      = yield :head
  %body
    .container-lg
      = yield